% test imc.m and ims.m for compatibility with matlab and octave
clear

load mc.dat % data from La Selva meteorological station
%lsm=mc(34:34+193,:);t=lsm(:,1);
lsm=mc;t=lsm(:,1);
pr=lsm(:,2);ta=lsm(:,3);rh=lsm(:,4);

% Set parameters and variables as in Evans (2007)
  c1 = 0.74;
  c2 = -0.0285;
  c3 = 10;
  c4 = 23/33;
  c5 = 3;
  c6 = 6;
  c7 = 27.17;
  c8 = 0.45;
  c9 = 20;
  c10=4290; % first constant for stomatal conductance calc (mb mol m-2 s-1)
  c11=-43; % second constant for stomatal conductance (mmol m-2 s-1)
  dfs=32; % diffusive fractionation  through stomata (per mil)
  dfb=21; % diffusive fractionation  through boundary layer (per mil)
  efc=27; % equilibrium fractionation between C=O and water (per mil)
  blc=2100; % boundary layer conductance (mmol m-2 s-1) [Reich et al., 2004]
  pl=0.018; % effective length for the Peclet effect (m)
  feo=0.42; % proportion of exchangeable oxygen in cellulose [Roden et al. 2000]
  fwxm= 1.0; % proportion of xylem water in meristem [Barbour et al. 2002]
                                                                                                                              
  c=[dfs dfb efc blc c10 c11 pl feo fwxm c1 c2 c3 c4 c5 c6 c7 c8 c9 ];

tic
  [o18e,o18l,o18s,o18c,o18cc,mcerr,o18ccp]=imc(lsm(:,2),lsm(:,3),lsm(:,4),c(1),c(2),c(3),c(4),c(5),c(6),c(7),c(8),c(9),c(10),c(11),c(12),c(13),c(14),c(15),c(16),c(17),c(18));
toc

%% plotting will only work in matlab
figure(1)
subplot(211) % o18cc
  plot(t,o18cc,'k',t,mcerr(:,9),'y');
%  legend('default params','MC +/-20% values 95% conf int')
%  legend boxoff
  hold on
  fill([t;flipud(t)],[mcerr(:,9);flipud(mcerr(:,10))],'y','edgecolor','y');
  axis([1985 2001 18 34])
  plot(t,o18cc,'k')
 
  hold off
  grid
  set(gca,'FontName','Times','Fontsize',16)
  set(gca,'YTick',[18:2:34]);
  set(gca,'XTick',[1985:2:2001])
    title('sensitivity of model to parameters and variables')
   ylabel('modeled \delta^{18}O')
text(1985.24,33,'a','Fontname','Times','Fontsize',16);

